SystemOrganization addCategory: #MUI!

Morph subclass: #MUIEnvelopeEditorMorph
	instanceVariableNames: 'isSelecting selectionStart selection selectionPos samples newSamples selectionRect selectedSamples windowSize a1 b1 weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MUI'!

!MUIEnvelopeEditorMorph methodsFor: 'curve based solver' stamp: 'yo 8/29/2016 16:13'!
adjustWindow: window with: diffY

	| width x windowFirst curve ds proposedDs newHeight origHeight ratio newProposedS now newProposedRemaining remaining base |
	diffY = 0 ifTrue: [^ #()].
	windowFirst := window first.

	base := (samples at: window first - 1) y.
	width := window size asFloat.
	ds := (0 to: window size - 1) collect: [:w | (samples at: w + windowFirst) y - (samples at: (w - 1) + windowFirst) y].

	"We take the suggested curve, which is just linearly scaled version of the curve in the window and for each differential, we multiply that with a non-linear curve to 'allow' the part that is far away from the boundary to change more freely."

	curve := (1 to: window size) collect: [:w | 
		x := w <= (window size / 2)
			ifTrue: [w * 2 / width]
			ifFalse: [window size - w / (width / 2)].
		x * x * x].

	origHeight := ((samples at: window last) - (samples at: window first - 1)) y.
	newHeight := origHeight + diffY.
	origHeight ~= 0 ifTrue: [
		proposedDs := ds * (newHeight / origHeight asFloat)]
	ifFalse: [
		proposedDs := (1 to: window size) collect: [:w | newHeight / width]].

	remaining := proposedDs - ds.

	newProposedRemaining := remaining * curve.
	ratio := remaining sum / newProposedRemaining sum.

	newProposedRemaining := newProposedRemaining * ratio.

	now := 0.
	newProposedS := (1 to: window size) collect: [:w |
		now := now + ((ds at: w) + (newProposedRemaining at: w))].

	^ window collect: [:s |
		(samples at: s) x@ (((newProposedS at: (s - windowFirst + 1)) + base))].
! !

!MUIEnvelopeEditorMorph methodsFor: 'curve based solver' stamp: 'yo 8/30/2016 10:01'!
adjustWindowLeft: diffY

	| window windowFirst |
	windowFirst := 1 max: (selectedSamples first first - windowSize).
	window := windowFirst to: selectedSamples first first - 1.
	^ self adjustWindow: window with: diffY.
	! !

!MUIEnvelopeEditorMorph methodsFor: 'curve based solver' stamp: 'yo 8/30/2016 10:01'!
adjustWindowRight: diffY

	| window windowFirst |
	windowFirst := 1 max: (selectedSamples last first + 1).
	window := windowFirst to: windowFirst + windowSize - 1.
	^ self adjustWindowRight: window with: diffY
! !

!MUIEnvelopeEditorMorph methodsFor: 'curve based solver' stamp: 'yo 8/30/2016 10:01'!
adjustWindowRight: window with: diffY

	| width x windowFirst curve ds proposedDs newHeight origHeight ratio newProposedS now newProposedRemaining remaining base |
	diffY = 0 ifTrue: [^ #()].
	windowFirst := window first.

	base := (newSamples at: window first - 1) y.
	width := window size asFloat.
	ds := (1 to: window size) collect: [:w | (samples at: w + windowFirst) y - (samples at: (w - 1) + windowFirst) y].

	"We take the suggested curve, which is just linearly scaled version of the curve in the window and for each differential, we multiply that with a non-linear curve to 'allow' the part that is far away from the boundary to change more freely."

	curve := (1 to: window size) collect: [:w | 
		x := w <= (window size / 2)
			ifTrue: [w * 2 / width]
			ifFalse: [window size - w / (width / 2)].
		x * x * x].

	origHeight := ((samples at: window first) - (samples at: window last + 1)) y.
	newHeight := origHeight + diffY.
	
	origHeight ~= 0 ifTrue: [
		proposedDs := ds * (newHeight / origHeight asFloat)]
	ifFalse: [
		proposedDs := (1 to: window size) collect: [:w | newHeight / width negated]].

	remaining := proposedDs - ds.

	newProposedRemaining := remaining * curve.
	ratio := remaining sum / newProposedRemaining sum.

	newProposedRemaining := newProposedRemaining * ratio.

	now := 0.
	newProposedS := (1 to: window size) collect: [:w |
		now := now + ((ds at: w) + (newProposedRemaining at: w))].

	^ window collect: [:s | (samples at: s) x@ (((newProposedS at: (s - windowFirst + 1)) + base))]
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/29/2016 15:26'!
commitEdit
	selectedSamples := nil.
	samples := newSamples.
	newSamples := nil.
	selection := nil.
! !

!MUIEnvelopeEditorMorph methodsFor: 'drawing' stamp: 'yo 8/29/2016 15:13'!
drawOn: aCanvas 
	"Display the receiver, a spline curve, approximated by straight 
	line segments."
	| s |
	super drawOn: aCanvas.
	s := newSamples ifNil: [samples].
	aCanvas translateBy: self position during: [:c |
		c drawPolygon: (s collect: [:p | p x@(self height - p y rounded)]) fillStyle: Color gray.
		"31 to: 50 do: [:i |
			q := samples at: i.
			c fillRectangle: (i@(self height - q y rounded) corner: (i + 1)@self height) fillStyle: (Color blue alpha: 0.2)]"].
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 15:17'!
handlesMouseDown: evt
	^ true.
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 15:17'!
handlesMouseMove: evt
	^ isSelecting
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 15:17'!
handlesMouseUp: evt
	^ isSelecting! !

!MUIEnvelopeEditorMorph methodsFor: 'initialize' stamp: 'yo 8/30/2016 10:01'!
initialize
	super initialize.
	self color: Color white.
	samples := ((1 to: 100) collect: [:i | i@i]), ((101 to: 200) collect: [:i | i@100]), ((201 to: 300) collect: [:i | i@(301 - i)]).
	self extent: samples max + (50@50).
	isSelecting := false.
	windowSize := 20.
	weight := 1.! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 15:13'!
mouseDown: evt

	| local |
	local := evt cursorPoint - self position.
	isSelecting := true.
	selectionStart := local.
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 16:11'!
mouseMove: evt
	| local rect |
	isSelecting ifTrue: [
		local := evt cursorPoint - self position.
		rect := selectionStart corner: local.
		selectionPos := rect origin.
		selectionRect := (rect origin x@(self height - rect bottom)) extent: rect extent.
	].
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/25/2016 16:16'!
mouseUp: evt
	isSelecting := false.
	selectedSamples := ((1 to: samples size) select: [:s | selectionRect containsPoint: (samples at: s)]) collect: [:s | {s. samples at: s}].
	selection := MUISelection new.
	selection
		extent: selectionRect extent.
	selection position: selectionPos + self position.
	selection color: (Color blue alpha: 0.5).
	selection editor: self.
	self addMorph: selection.
! !

!MUIEnvelopeEditorMorph methodsFor: 'accessing' stamp: 'yo 8/26/2016 11:33'!
samples
	^ samples
	! !

!MUIEnvelopeEditorMorph methodsFor: 'debugging' stamp: 'yo 8/26/2016 13:34'!
samples: anArray
	samples := anArray.
	self extent: samples max + (50@50).
	self changed.
! !

!MUIEnvelopeEditorMorph methodsFor: 'events' stamp: 'yo 8/29/2016 15:14'!
selectionMoveBy: diff
	| leftSamples rightSamples |
	newSamples := samples collect: [:e | e].
	selectedSamples ifNotNil: [
		selectedSamples do: [:pair |
			| p |
			p := pair second.
			newSamples at: pair first put: p x@(p y + diff y)]].
	leftSamples := self adjustWindowLeft: diff y.
	rightSamples := self adjustWindowRight: diff y.
	
	leftSamples do: [:s | newSamples at: s x  put: s].
	rightSamples do: [:s | newSamples at: s x put: s].
	self changed.
! !

!MUIEnvelopeEditorMorph methodsFor: 'experimental solver' stamp: 'yo 8/26/2016 15:28'!
setupA1Bottom: diff withinWindow: window
	| row |
	row := a1 at: (window size + 1).
	row at: 1 put: 10.

	row := a1 at: (window size + 2).
	row at: 1 put: weight negated.
	row at: 2 put: weight.

	3 to: (window size - 2) do: [:i |
		row := a1 at: (window size + i).
		row at: (i - 2) put: weight.
		row at: (i - 1) put: -2 * weight.
		row at: i put: weight].

	row := a1 at: (window size + (window size - 1)).
	row at: window size - 1 put: weight negated.
	row at: window size put: weight.
	
	row := a1 at: (window size + window size).
	row at: window size put: 10.
! !

!MUIEnvelopeEditorMorph methodsFor: 'experimental solver' stamp: 'yo 8/26/2016 14:07'!
setupA1Top: diff withinWindow: window
	| newHeight origHeight ratio |
	origHeight := ((samples at: window last) - (samples at: window first - 1)) y.
	newHeight := origHeight + diff.
	ratio := origHeight / newHeight asFloat.
	1 to: window size do: [:i | (a1 at: i) at: i put: ratio].
! !

!MUIEnvelopeEditorMorph methodsFor: 'experimental solver' stamp: 'yo 8/29/2016 14:46'!
setupB: diffY withinWindow: window
	| outsideD outsideS topB bottomB base |
	base := (samples at: window first - 1) y.
	window first = 1 ifTrue: [
		outsideD := 0.
		outsideS := 0]
	ifFalse: [
		window first = 2 ifTrue: [
			outsideD := 0.
			outsideS := (samples at: 1) y]
		ifFalse: [
			outsideD := ((samples at: window first - 1) - (samples at: window first - 2)) y.
			outsideS := (samples at: window first - 1) y]].
	bottomB := (FloatArray with: 10 * outsideD with: outsideD),
		(FloatArray new: window size - 4).
	topB := window collect: [:w | (samples at: w) y - base].
	window last = samples size ifTrue: [
		outsideD := 0.
		outsideS := 0]
	ifFalse: [
		window last = (samples size - 1) ifTrue: [
			outsideD := 0.
			outsideS := samples last]
		ifFalse: [
			outsideD := ((samples at: window last + 2) - (samples at: window last + 1)) y.
			outsideS := (samples at: window last + 1) y - base]].
	
	b1 := topB, bottomB, (FloatArray with: outsideD with: 10 * (outsideS - outsideD)).
	
! !

!MUIEnvelopeEditorMorph methodsFor: 'experimental solver' stamp: 'yo 8/29/2016 14:46'!
solve: window
	| a b base solution newSamples |
	a := LapackSGEMatrix rows: a1.
	b := LapackSGEMatrix rows: (b1 collect: [:e | {e}]).
	base := (samples at: window first - 1) y.
	solution := (LapackLeastSquareProblem matrix: a rhsMatrix: b) solution.
	solution := (((1 to: solution nrow) collect: [:i | solution at: i]) + base).
	newSamples := (1 to: samples size) collect: [:s |
		(window includes: s)
			ifTrue: [(samples at: s) x@ (solution at: (s - window first + 1))]
			ifFalse: [samples at: s]].
	^ newSamples.
! !

Morph subclass: #MUISelection
	instanceVariableNames: 'clickPoint origPos editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MUI'!

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/25/2016 16:00'!
editor: anEditor
	editor := anEditor
! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/25/2016 15:59'!
handlesMouseDown: evt
	^ true.
! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/25/2016 16:14'!
handlesMouseMove: evt
	^ clickPoint notNil

! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/25/2016 16:14'!
handlesMouseUp: evt
	^ true
! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/25/2016 16:17'!
mouseDown: evt
	clickPoint := evt cursorPoint.
	origPos := self position.
! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/29/2016 14:57'!
mouseMove: evt
	| diff |
	diff := evt cursorPoint - clickPoint.
	self position: origPos x@(origPos y + diff y).
	editor selectionMoveBy: diff negated.
! !

!MUISelection methodsFor: 'as yet unclassified' stamp: 'yo 8/29/2016 15:22'!
mouseUp: evt
	clickPoint := nil.
	editor commitEdit.
	self delete.! !
